!INCLUDE <lynxcc65.mak>

target = tutorial-sprites.lnx
objects = lynx-160-102-16.o lynx-stdjoy.o \
					tutorial.o \
					robot.o robotcentered.o leaves.o

robotcentered.o: robot.bmp
	$(SPRPCK) -t6 -p2 -a004003 robot.bmp
	$(ECHO) .global _robotcentered > $*.s
	$(ECHO) .segment "$(RODATA_SEGMENT)" >> $*.s
	$(ECHO) _robotcentered: .incbin "robot.spr" >> $*.s
	$(AS) -t lynx -o $@ $(AFLAGS) $*.s

leaves.o: leaves.bmp
	$(SPRPCK) -t6 -p2 -r004001 -S008004 leaves.bmp
	$(ECHO) .global _leave0 > $*.s
	$(ECHO) .global _leave1 >> $*.s
	$(ECHO) .global _leave2 >> $*.s
	$(ECHO) .global _leave3 >> $*.s
	$(ECHO) .segment "$(RODATA_SEGMENT)" >> $*.s
	$(ECHO) _leave0: .incbin "leaves000000.spr" >> $*.s
	$(ECHO) _leave1: .incbin "leaves000001.spr" >> $*.s
	$(ECHO) _leave2: .incbin "leaves000002.spr" >> $*.s
	$(ECHO) _leave3: .incbin "leaves000003.spr" >> $*.s
	$(AS) -t lynx -o $@ $(AFLAGS) $*.s

$(target) : $(objects) 
	$(CL) -t $(SYS) -o $@ $(objects) lynx.lib
	$(CP) $@ .\$(BUILD)\$@

all: $(target)
	
clean:
	$(RM) *.tgi
	$(RM) *.s
	$(RM) *.joy
	$(RM) *.o
	$(RM) *.lnx
 